int SLOG_STM_ReadFRAME( SLOG_STREAM *slog )
{
    SLOG_uint32 Nbytes_read;
    int         ierr;

#if defined( DEBUG )
    SLOG_fptr  slogfile_loc_cur;
    SLOG_fptr  ifptr2framehdr;
    int        ifptr;
#endif

#if defined( DEBUG )
        fprintf( errfile, __FILE__":SLOG_STM_ReadFRAME() - A\n" );
        slogfile_loc_cur = ftell( slog->fd );
        ifptr = SLOG_STM_ifptr2FrameDirEntry( slog );
        if ( ifptr >= ( slog->frame_dir ).Nframe ) {
            fprintf( errfile, __FILE__":SLOG_WriteFRAME() - "
                              "SLOG_STM_ifptr2FrameDirEntry() returns %d "
                              ">= ( slog->frame_dir ).Nframe(%d)\n",
                              ifptr, ( slog->frame_dir ).Nframe );
            fflush( errfile );
            return SLOG_FAIL;
        }
        ifptr2framehdr = ( (slog->frame_dir).entries[ ifptr ] ).fptr2framehdr;
        if ( slogfile_loc_cur != ifptr2framehdr ) {
            fprintf( errfile, __FILE__":SLOG_WriteFRAME() - "
                              "Inconsistency in File Pointers BEFORE calling "
                              "fbuf_refill( frame buffer ) at line %d\n",
                              __LINE__ );
            fprintf( errfile, "       ""- slogfile_loc_cur(%ld) != "
                              "( slog->frame_dir_entry ).fptr2framehdr(%ld)\n",
                              slogfile_loc_cur, ifptr2framehdr );
            fflush( errfile );
            return SLOG_FAIL;
        }
#endif

    /* WE CAN UPDATE slog->frame_dir_entry here */

    /*  Read the frame buffer from the disk/file  */
    ierr = fbuf_refill( slog->fbuf );
    if ( ierr == EOF ) {
        fprintf( errfile, __FILE__":SLOG_STM_ReadFRAME() - "
                          "fbuf_refill( frame buffer ) fails\n" );
        fflush( errfile );
        return SLOG_FAIL;
    }
  /*
      Update the SLOG_STREAM's current slog file location, slog->file_loc,
      and file pointer to the File Directory Entry
  */
    slog->file_loc      = ( SLOG_fptr ) ftell( slog->fd );
    slog->file_dir_cur += SLOG_typesz[ FrameDirEntry ];



    Nbytes_read = 0;

    /*  Get the Frame Header from the frame buffer  */
    ierr = SLOG_STM_WithdrawFrameHdr( &( slog->frame_hdr ), slog->fbuf );
    if ( ierr == SLOG_FAIL ) {
        fprintf( errfile, __FILE__":SLOG_STM_ReadFRAME() - "
                          "SLOG_STM_WithdrawFrameHdr() fails !!\n" );
        fflush( errfile );
        return SLOG_FAIL;
    }
    Nbytes_read += ierr;

    /*  Get the Incoming Bbuf from the frame buffer  */
    ( slog->inc_bbuf )->Nbytes_in_file = ( slog->frame_hdr ).Nbytes_inc; 
    ( slog->inc_bbuf )->count_irec     = ( slog->frame_hdr ).Nrec_inc;
    ierr = SLOG_STM_WithdrawBBuf( slog->inc_bbuf, slog->rec_defs, slog->fbuf );
    if ( ierr != SLOG_SUCCESS ) {
        fprintf( errfile, __FILE__":SLOG_STM_ReadFRAME() - "
                          "SLOG_STM_WithdrawBBuf( slog->INCOMMING_Bbuf ) "
                          "fails !!\n" );
        fflush( errfile );
        return SLOG_FAIL;
    }
    Nbytes_read += ( slog->inc_bbuf )->Nbytes_in_file;

    /*  Get the Current  Bbuf from the frame buffer  */
    ( slog->cur_bbuf )->Nbytes_in_file = ( slog->frame_hdr ).Nbytes_cur; 
    ( slog->cur_bbuf )->count_irec     = ( slog->frame_hdr ).Nrec_cur;
    ierr = SLOG_STM_WithdrawBBuf( slog->cur_bbuf, slog->rec_defs, slog->fbuf );
    if ( ierr != SLOG_SUCCESS ) {
        fprintf( errfile, __FILE__":SLOG_STM_ReadFRAME() - "
                          "SLOG_STM_WithdrawBBuf( slog->CURRENT_Bbuf ) "
                          "fails !!\n" );
        fflush( errfile );
        return SLOG_FAIL;
    }
    Nbytes_read += ( slog->cur_bbuf )->Nbytes_in_file;

    return Nbytes_read;
}
